/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.main.ConfigManager
 *  fire.pb.util.DateValidate
 *  gnet.QueryOrderResponse
 *  mkdb.Executor
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.ChargeHistory
 *  xbean.ChargeOrder
 *  xbean.ChargeRecord
 *  xbean.Pod
 *  xbean.Properties
 *  xbean.RoleChargeLimit
 *  xtable.Auuserinfo
 *  xtable.Chargehistory
 *  xtable.Chargeorder
 *  xtable.Properties
 *  xtable.Roleschargelimit
 */
package fire.pb.fushi;

import fire.pb.fushi.CConfirmCharge;
import fire.pb.fushi.ChargeConfig;
import fire.pb.fushi.CheckCharge;
import fire.pb.fushi.FushiManager;
import fire.pb.fushi.Module;
import fire.pb.fushi.PQueryOrderResponseNew;
import fire.pb.fushi.SAddCash;
import fire.pb.fushi.SAddCashPCard;
import fire.pb.fushi.SConfirmCharge;
import fire.pb.main.ConfigManager;
import fire.pb.util.DateValidate;
import gnet.QueryOrderResponse;
import java.util.Calendar;
import java.util.concurrent.TimeUnit;
import mkdb.Executor;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.ChargeHistory;
import xbean.ChargeOrder;
import xbean.ChargeRecord;
import xbean.Pod;
import xbean.RoleChargeLimit;
import xtable.Auuserinfo;
import xtable.Chargehistory;
import xtable.Chargeorder;
import xtable.Properties;
import xtable.Roleschargelimit;

public class PPayConfirm
extends Procedure {
    private final long roleid;
    private final int userid;
    private final CConfirmCharge cConfirmCharge;

    public PPayConfirm(long roleid, int userid, CConfirmCharge cConfirmCharge) {
        this.roleid = roleid;
        this.userid = userid;
        this.cConfirmCharge = cConfirmCharge;
    }

    private boolean checkChargeLimit(ChargeConfig cfg) {
        RoleChargeLimit rcl = Roleschargelimit.get((Long)this.roleid);
        if (rcl != null) {
            ChargeRecord cr = (ChargeRecord)rcl.getChargeslimit().get(new Integer(this.cConfirmCharge.goodid));
            if (cr != null) {
                long now = Calendar.getInstance().getTimeInMillis();
                long lastchargetime = cr.getChargetime();
                if (DateValidate.inTheSameDay((long)lastchargetime, (long)now)) {
                    if (cr.getChargecount() >= cfg.chargecount) {
                        FushiManager.logger.warn((Object)("角色[" + this.roleid + "]商品[" + this.cConfirmCharge.goodid + "]今天已经充值次数:" + cr.getChargecount() + ",超过上限" + cfg.chargecount));
                        return false;
                    }
                    FushiManager.logger.info((Object)("角色[" + this.roleid + "]商品[" + this.cConfirmCharge.goodid + "]今天已经充值次数:" + cr.getChargecount()));
                } else {
                    cr.setChargecount(0);
                }
            } else {
                ChargeRecord newCr = Pod.newChargeRecord();
                newCr.setChargecount(0);
                newCr.setChargetime(0L);
                rcl.getChargeslimit().put(new Integer(this.cConfirmCharge.goodid), newCr);
            }
        } else {
            RoleChargeLimit newRcl = Pod.newRoleChargeLimit();
            ChargeRecord newCr = Pod.newChargeRecord();
            newCr.setChargecount(0);
            newCr.setChargetime(0L);
            newRcl.getChargeslimit().put(new Integer(this.cConfirmCharge.goodid), newCr);
            Roleschargelimit.insert((Long)this.roleid, (RoleChargeLimit)newRcl);
        }
        return true;
    }

    protected boolean process() throws Exception {
        if (Module.getIsYYBUser(this.userid)) {
            FushiManager.logger.error((Object)"应用宝服务器，符石完全托管，禁用原来订单充值逻辑！");
            return true;
        }
        if (ConfigManager.CHARGEENABLE == 0) {
            FushiManager.logger.error((Object)"系统配置sys.properties未打开充值！");
            return true;
        }
        FushiManager.logger.info((Object)("角色[" + this.roleid + "]确认充值.商品:" + this.cConfirmCharge.goodid + ",数量:" + this.cConfirmCharge.goodnum));
        ChargeConfig sChargeCfg = null;
        sChargeCfg = Module.GetPayServiceType() == 0 ? (ChargeConfig)ConfigManager.getInstance().getConf(SAddCash.class).get(this.cConfirmCharge.goodid) : (ChargeConfig)ConfigManager.getInstance().getConf(SAddCashPCard.class).get(this.cConfirmCharge.goodid);
        if (sChargeCfg == null) {
            FushiManager.logger.error((Object)("角色[" + this.roleid + "]确认充值.未找到商品id=" + this.cConfirmCharge.goodid + "的配置!"));
            return false;
        }
        if (ConfigManager.isChargeLimit && sChargeCfg.chargecount >= 0 && !this.checkChargeLimit(sChargeCfg)) {
            SConfirmCharge sConfirmCharge = new SConfirmCharge();
            sConfirmCharge.extra = "191031";
            PPayConfirm.psendWhileRollback((long)this.roleid, (Protocol)sConfirmCharge);
            return false;
        }
        if (!ConfigManager.OPEN_DY && sChargeCfg.kind == 2) {
            FushiManager.logger.error((Object)("角色[" + this.roleid + "]确认充值.kind=" + sChargeCfg.kind + ",但订阅类型已经关闭!"));
            return false;
        }
        xbean.Properties properties = Properties.select((Long)this.roleid);
        if (properties == null) {
            FushiManager.logger.error((Object)("角色[" + this.roleid + "]未找properties!"));
            return false;
        }
        String nickname = Auuserinfo.selectNickname((Integer)properties.getUserid());
        if (nickname == null) {
            FushiManager.logger.error((Object)("角色[" + this.roleid + "]的Auuserinfo未找Nickname!"));
            return false;
        }
        FushiManager.logger.info((Object)("角色[" + this.roleid + "]确认充值.Nickname:" + nickname));
        String platType = nickname.isEmpty() || nickname.length() <= 0 ? "xxxx" : nickname.substring(0, 4);
        if (!properties.getPlatformuid().contains("@@")) {
            platType = "xxxx";
        }
        FushiManager.logger.info((Object)("角色[" + this.roleid + "]确认充值.platType:" + platType));
        int rmbnum = sChargeCfg.sellpricenum * this.cConfirmCharge.goodnum;
        if (rmbnum <= 0) {
            FushiManager.logger.error((Object)("角色[" + this.roleid + "]购买物品价格小于0！"));
            return false;
        }
        ChargeOrder chargeOrder = Pod.newChargeOrder();
        long chargeSn = Chargeorder.insert((ChargeOrder)chargeOrder);
        chargeOrder.setStatus(1);
        chargeOrder.setNum(rmbnum);
        chargeOrder.setPlatformuid(properties.getPlatformuid());
        chargeOrder.setPlattype(platType);
        chargeOrder.setRoleid(this.roleid);
        chargeOrder.setUserid(properties.getUserid());
        chargeOrder.setCreatetime(System.currentTimeMillis());
        chargeOrder.setGoodid(this.cConfirmCharge.goodid);
        chargeOrder.setGoodnum(this.cConfirmCharge.goodnum);
        FushiManager.logger.info((Object)("角色[" + this.roleid + "],[" + chargeOrder.getPlatformuid() + "]请求订单号:" + chargeSn));
        ChargeHistory chargeHistory = Chargehistory.get((Integer)properties.getUserid());
        if (chargeHistory == null) {
            chargeHistory = Pod.newChargeHistory();
            Chargehistory.insert((Integer)properties.getUserid(), (ChargeHistory)chargeHistory);
        }
        ChargeOrder chargeOrder2 = chargeOrder.copy();
        chargeHistory.getCharges().put(chargeSn, chargeOrder2);
        SConfirmCharge sConfirmCharge = new SConfirmCharge();
        sConfirmCharge.billid = chargeSn;
        sConfirmCharge.goodid = this.cConfirmCharge.goodid;
        sConfirmCharge.goodnum = this.cConfirmCharge.goodnum;
        sConfirmCharge.goodname = String.valueOf(sChargeCfg.sellnum) + sChargeCfg.name;
        sConfirmCharge.price = rmbnum;
        sConfirmCharge.serverid = ConfigManager.getGsZoneId();
        sConfirmCharge.extra = "";
        if (!platType.equals("xxxx")) {
            if (ConfigManager.getChargeDirect()) {
                FushiManager.logger.info((Object)("角色[" + this.roleid + "]确认充值.单号:" + chargeSn + ",等待平台直接回调端口" + ConfigManager.getCallBackPort() + "的接口!"));
                PPayConfirm.psendWhileCommit((long)this.roleid, (Protocol)sConfirmCharge);
            } else {
                FushiManager.logger.info((Object)("角色[" + this.roleid + "]确认充值.找到处理平台,开始十秒轮询,单号:" + chargeSn));
                Executor.getInstance().schedule((Runnable)new CheckCharge(chargeSn), 10L, TimeUnit.SECONDS);
                FushiManager.logger.info((Object)("生成一个新的充值订单请求.roleid:" + this.roleid + ",platformuid:" + properties.getPlatformuid() + ",chargeGameSn:" + chargeSn + ",rmbnum:" + rmbnum));
                PPayConfirm.psendWhileCommit((long)this.roleid, (Protocol)sConfirmCharge);
            }
        } else {
            FushiManager.logger.info((Object)("角色[" + this.roleid + "]确认充值.测试用绕过第三方直接响应充值请求,单号:" + chargeSn));
            QueryOrderResponse response = new QueryOrderResponse();
            response.errorcode = 0;
            response.orderserialgame = Long.toString(chargeSn);
            response.orderserialplat = Long.toString(chargeSn);
            response.platid = platType;
            response.userid = properties.getUserid();
            response.restype = 1;
            response.vars.resize(4);
            response.vars.setByte(0, (byte)0);
            response.vars.setByte(1, (byte)0);
            response.vars.setByte(2, (byte)0);
            response.vars.setByte(3, (byte)0);
            new PQueryOrderResponseNew(response).call();
        }
        return true;
    }
}

